# saga::session Class Reference

Almost all SAGA objects are created in a SAGA session, and are associated with this (and only this) session for their whole life time. More...

`#include <session.hpp>`

Inheritance diagram for saga::session:

[legend]

List of all members.

## Public Member Functions
| session (bool default_session=false)
| Creates the object.
| session (saga::object const &obj)
| Creates the object.
| ~session (void)
| Destroys the object.
session & | operator= (saga::object const &o)
| Brief description starts here.
void | add_context (saga::context const &c)
| Attaches a security context to a session.
void | remove_context (saga::context const &c)
| Detaches a security context from a session.
std::vector< saga::context > | list_contexts () const
| Retrieves all contexts attached to a session.
## Friends
bool | operator== (session const &lhs, session const &rhs)
| Brief description starts here.

## Detailed Description

Almost all SAGA objects are created in a SAGA session, and are associated with this (and only this) session for their whole life time.

A session instance to be used on ob ect instantiation can explicitly be given as first parameter to the SAGA object instantiation call (CONSTRUCTOR). If the session is omitted as first parameter, a default session is used, with default security context(s) attached. The default session can be obtained by passing true to the session CONSTRUCTOR.

## Constructor & Destructor Documentation

saga::session::session | ( | bool | default_session = `false` | ) | `[explicit]`

Creates the object.

saga::session::session | ( | saga::object const & | obj | ) | `[explicit]`

Creates the object.

Returns:
  The newly created object.

saga::session::~session | ( | void |  | ) |

Destroys the object.

## Member Function Documentation

session& saga::session::operator= | ( | saga::object const & | o | ) |

Brief description starts here.

void saga::session::add_context | ( | saga::context const & | c | ) |

Attaches a security context to a session.

Parameters:

  | c | Security context to add.

void saga::session::remove_context | ( | saga::context const & | c | ) |

Detaches a security context from a session.

Parameters:

  | c | Security context to remove.

std::vector<saga::context> saga::session::list_contexts | ( |  | ) | const

Retrieves all contexts attached to a session.

Returns:
  List of contexts of this session.

## Friends And Related Function Documentation

bool operator== | ( | session const & | lhs,
|  | session const & | rhs |
| ) |  |  | `[friend]`

Brief description starts here.

The documentation for this class was generated from the following file:

- session.hpp